# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify Alma, CentOS, CentOS Stream and Rocky Linux as rhel
%if "%{__distinit}" == "a" || "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "cs" || "%{__distinit}" == "rl"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Test-API
Version:	0.010
Release:	17.%{__distinit}%{__distvers}
Summary:	Test a list of subroutines provided by a module
License:	Apache-2.0
URL:		https://metacpan.org/release/Test-API
Source0:	https://cpan.metacpan.org/modules/by-module/Test/Test-API-%{version}.tar.gz
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl-generators
BuildRequires:	perl-interpreter
BuildRequires:	perl(ExtUtils::MakeMaker) >= 6.17
# Module Runtime
BuildRequires:	perl(strict)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(Test::Builder::Module) >= 0.86
BuildRequires:	perl(warnings)
# Test Suite
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(lib)
BuildRequires:	perl(Test::Builder::Tester) >= 1.18
BuildRequires:	perl(Test::More)
# Optional Test Requirements
BuildRequires:	perl(CPAN::Meta)
BuildRequires:	perl(CPAN::Meta::Requirements) >= 2.120900
# Dependencies
%if 0%{?fedora} < 38 && 0%{?rhel} < 10
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
%endif

%description
This simple test module checks the subroutines provided by a module. This is
useful for confirming a planned API in testing and ensuring that other
functions aren't unintentionally included via import.

%prep
%setup -q -n Test-API-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} -c %{buildroot}

%check
make test

%files
%license LICENSE
%doc Changes CONTRIBUTING.mkdn README
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::API.3*

%changelog
* Mon May 22 2023 Paul Howarth <paul@city-fan.org> - 0.010-17
- Use SPDX-format license tag
- Use %%license unconditionally

* Mon Feb 19 2018 Paul Howarth <paul@city-fan.org> - 0.010-1
- Update to 0.010
  - Revised internals for constants/subrefs in the stash (a breaking change
    planned for Perl 5.28)
- BR: perl-generators unconditionally
- BR: perl-interpreter rather than perl

* Tue Apr  4 2017 Paul Howarth <paul@city-fan.org> - 0.008-1
- Update to 0.008
  - Fixed tests for perls without '.' in @INC
- Drop support for EOL distributions prior to F-13:
  - Drop BuildRoot: and Group: tags
  - Drop explicit buildroot cleaning in %%install section
  - Drop explicit %%clean section

* Wed Sep 28 2016 Paul Howarth <paul@city-fan.org> - 0.005-7
- BR: perl-generators where available
- Simplify find command using -delete
- Use %%license where possible

* Thu Apr 24 2014 Paul Howarth <paul@city-fan.org> - 0.005-1
- Update to 0.005
  - Common methods treated as private (e.g. AUTOLOAD, BUILD) are ignored

* Fri Mar 14 2014 Paul Howarth <paul@city-fan.org> - 0.004-1
- Update to 0.004
  - class_api_ok function tests methods that may be provided the module
    tested or a superclass
  - Dropped dependencies on superclass and Devel::Symdump

* Thu Mar 13 2014 Paul Howarth <paul@city-fan.org> - 0.003-1
- Initial RPM version
